#!/usr/bin/env og
# ==
# --Project: Open Grid
# --Author: Sing.Yu <scaner@gmail.com>
# --Client-Script: Set opengrid-info hostdb
# ==

import sys, os
import socket

import pprint
import og.lib.network
from og.lib.utility import RandomString
import og.constants as OC

import grid_info
GI = grid_info.I

def Main(nodeid):
	C = grid_info.OGClient()
	nodeinfoaddr = {'.': 'hive', ':':'nodeinfo'}

	pin = RandomString(16)

	C.Call({
		'!': nodeinfoaddr,
		'_': 'S.del',
		'param': {
			'node': nodeid,
		}
	})
		
	C.Call({
		'!': nodeinfoaddr,
		'_': 'S.save',
	})
	C.close()

if __name__ == '__main__':
	Main(sys.argv[1])
