#!/usr/bin/env og
# ==
# --Project: Open Grid
# --Author: Sing.Yu <scaner@gmail.com>
# --Client-Script: Upgrade all nodes software
# ==

import time
import og.lib.network
import og.constants

# ---
#DOMAIN = 'opengrid-dev.yuxin.us'
import grid_info

def UpgradeAllNodes():
	# 
	directNodes = ['dev']
	directRestart = []

	# hiveAddr
	C = grid_info.OGClient()

	nodesres = C.Call({
		'_': 'S.nodelist',
		'!': {'.': 'hive', ':': 'hive'},
	})['=']

	print 'online nodes: %s' % (', '.join(nodesres.keys()))

	nodes = {}
	for n in nodesres.keys():
		nodes[n] = {'state': 'INIT'}
	
	for n in directNodes:
		if n in nodes:
			del nodes[n]
			directRestart.append(n)
	
	for n in nodes.keys():
		C.sendMessage({
			'_': 'S.run0',
			'args': ['sh', '-c', 
				'easy_install -d $OPENGRID_HOME/lib/ogeggs '
				'-U -i http://ss-admin.io8.org/pypi opengrid'],
			'name': 'easy-install-upgrade',
			'!': {'.':n, ':':'main'},
			'~': 'easy-install-upgrade=%s=%.2f' % (n, time.time()),
			'stdout': True,
		})
	
	while len(nodes):
		m = C.recvMessage()
		if m['_'] != 'S.run0.finished':
			continue

		nodeid = m['@']['.']
		print '-- %s --' % nodeid
		print m['=']['stdout']

		if nodeid in nodes:
			C.sendMessage({
				'!': {'.': nodeid, ':':'main'},
				'_': 'S.restart',
			})
			del nodes[nodeid]
			print nodes.keys()

	for nodeid in directRestart:
		C.sendMessage({
			'!': {'.': nodeid, ':':'main'},
			'_': 'S.restart',
		})
	C.close()


# ---
if __name__ == '__main__':
	UpgradeAllNodes()

