# ==
# --Project: Open Grid
# --Author: Sing.Yu <scaner@gmail.com>
# --Application: GenUnitTest
# --Description: Generate empty unit test file for modules
# ==

import os, sys

def GenUnitTest(mname):
	if mname.find('/') and mname.endswith('.py'):
		mname = mname[:-3]

	mname = mname.replace('/', '.')
	mnames = mname.split('.')
	mname2 = ''.join([x.capitalize() for x in mnames])

	mname3 = list(mnames)
	mname3[-1] = 'tests_' + mname3[-1]
	fname = '/'.join(mname3) + '.py'

	if os.path.exists(fname):
		print '%s already exists' % fname
		sys.exit(0)
	
	print 'Generate %s' % fname

	fout = file(fname, 'w')
	fout.write(
'''# ==
# --Project: OpenGrid
# --Author: Sing.Yu <scaner@gmail.com>
# --UnitTest: %s
# ==

import os, sys
import unittest

import %s

class Test%s(unittest.TestCase):
	def test_Empty(self):
		pass
''' % (mname, mname, mname2))
	fout.close()


GenUnitTest(sys.argv[1])
