# ==
# --Project: Open Grid
# --Author: Sing.Yu <scaner@gmail.com>
# --Module: og.lib.network
# ==

import socket

#from cPickle import dumps as _dumps, loads as _loads
#from struct import pack as _pack, unpack as _unpack
from fastmap import fastdumps as _dumps, fastloads as _loads
from fastmap import int32pack, int32unpack

# ---
def Pack(params):
	#s = _dumps(params, -1)
	s = _dumps(params)
	l = len(s)
	#hs = _pack('!I', l)
	hs = int32pack(l)
	return hs + s

# ---
def Unpack(string):
	#l = _unpack('!I', string[:4])[0]
	l = int32unpack(string[:4])
	return l, _loads(string[4:4 + l])

# ---
def Unpack0(string):
	return _loads(string[4:])

Unpack_ = _loads
	
Dword2Str = int32pack
Str2Dword = int32unpack
# ---
#def Dword2Str(i):
#	return _pack('!I', i)
#	
#def Str2Dword(string):
#	return _unpack('!I', string)[0]
# ---

# ---
class OGClient:
	def __init__(self, S):
		if type(S) == socket.SocketType:
			self.socket = S
		elif type(S) == tuple:
			self.socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM, 0)
			self.socket.connect(S)
		else:
			self.socket = None
	
	def close(self):
		self.socket.close()
	
	def Call(self, params):
		self.sendMessage(params)
		return self.recvMessage()
	
	def sendMessage(self, params):
		msg = Pack(params)
		self.socket.send(msg)
		
	def recvMessage(self):
		header = self.socket.recv(4)
		
		if not header:
			return None
		buflen = Str2Dword(header)
		
		got = 0
		inbufs = []
		
		while got != buflen:
			buf = self.socket.recv(buflen - got)
			if not buf:
				return None
			got += len(buf)
			inbufs.append(buf)
		return Unpack_(''.join(inbufs))
