# ==
# --Project: OpenGrid
# --Author: Sing.Yu <scaner@gmail.com>
# --UnitTest: og.lib.osmeter.meter
# ==

import os, sys
import unittest

import og.lib.osmeter.meter

class TestOgLibOsmeterMeter(unittest.TestCase):
	def test_Partition(self):
		Partition = og.lib.osmeter.meter.Partition
		assert Partition('  CPU: 1024  ') == ('CPU', '1024')
		assert Partition('OK') == ('OK', '')
	
	def test_Slurp(self):
		Slurp = og.lib.osmeter.meter.Slurp
		SlurpLines = og.lib.osmeter.meter.SlurpLines

		import tempfile
		fd, fname = tempfile.mkstemp('.ut')
		os.write(fd, '''line0
line1
line2''')
		os.close(fd)

		assert Slurp(fname) == '''line0
line1
line2'''
		assert SlurpLines(fname) == ['line0\n', 'line1\n', 'line2']
