# ==
# --Project: OpenGrid
# --Author: Sing.Yu <scaner@gmail.com>
# --UnitTest: og.lib.logging
# ==

import os, sys
import time
import unittest
import StringIO


from og.lib.logging import *

class TestOgLibLogging(unittest.TestCase):
	def test_ImportLogCore(self):
		from og.lib.logging import logCore, C, LogCore
		assert isinstance(logCore, LogCore)
	
	def test_StdoutValue(self):
		# Keep sys.stdout
		stdout = sys.stdout
		sys.stdout = StringIO.StringIO()

		from og.lib.logging import C
		C.setNodeId('TEST')

		_L('Hello World')
		v = sys.stdout.getvalue()
		sys.stdout = stdout

		assert v[12] == 'L'
		assert v[14:] == 'Hello World\n'
