# ==
# --Project: Open Grid
# --Author: Sing.Yu <scaner@gmail.com>
# --Module: og.svc.ulogs
# ==

import time
import socket

import og.constants

# ---
ULOGS_VERSION = '0.1-r1'


# ---
class ULogs:
	def setup(self, port = og.constants.ULOG_PORT):
		self.port = port
		self.socket = socket.socket(socket.AF_INET, socket.SOCK_DGRAM, 0)
		self.socket.bind(('0.0.0.0', port))
	
	def run(self):
		while True:
			try:
				msg, addr = self.socket.recvfrom(500)
				tokens = msg.split('\0')
				if len(tokens) != 3:
					continue

				tag, nodeid, msg = tokens
				print '%s _%c_ %s [%s]' % (
					time.strftime('%m%d\'%H%M%S'),
					tag, msg, nodeid)

			except socket.error:
				pass

# ---
def Main():
	u = ULogs()
	u.setup()
	u.run()

# ---
if __name__ == '__main__':
	Main()
