# ==
# --Project: Open Grid
# --Author: Sing.Yu <scaner@gmail.com>
# --Application: Setup script
# ==

from og.versioninfo import version_info 
import time

VERSION = '0.1-r%d-%s' % (
	version_info['revno'], 
	#version_info['revision_id'].split('-')[1][:8],
	time.strftime('%Y%m%d%H%M'),
	)

try:
	from setuptools import setup, find_packages
	SETUPTOOLS = True

	additions = {
		'packages': find_packages(),
		'install_requires': [
			'fastmap >= 0.0.0.14',
		],
	}
except ImportError:
	from distutils.core import setup
	SETUPTOOLS = False
	additions = {
		'packages':['og', 'og.lib', 'og.svc', 'og.tests'],
	}



SetupInfo = {
	'name': 'opengrid',
	'version': VERSION,
	'author': 'Sing Yu',
	'author_email': 'scaner+opengrid@gmail.com',
	'description': ('A simple grid'),
	'long_description': \
	"""A simple grid written in Python""",
	'license': 'GPL2',
	'keywords': 'cluster gird network supercomputing',
	'url': 'http://opengrid.yuxin.us/',
	'download_url': 'http://opengrid.yuxin.us/opengrid-%s.tar.gz' % VERSION,
}

SetupInfo.update(additions)

setup(**SetupInfo)
